#!/bin/bash
#
# Ex.2022-7-31

# 取得今天日期
today=`date +"%b %_d"`

# 取得內網IP
CPANEL_INTERFACE=`ip -o link show | grep 'UP' | awk -F': ' '{print $2}'|grep -v lo | tail -n 1`
INTERNEL_IP=`ifconfig $CPANEL_INTERFACE| grep -Eo 'inet (addr:)?([0-9]*\.){3}[0-9]*' | grep -Eo '([0-9]*\.){3}[0-9]*' | grep -v '127.0.0.1'`

# 取得指定區間 secure log (3分鐘前)
touch /tmp/test.txt
awk -v Date1=`date +"%H:%M:%S" -d '-3 minute'` -v Date2=`date +"%H:%M:%S"` '$3 > Date1 && $3 < Date2' /var/log/secure > /tmp/test.txt

# 統計內網 ssh 登入失敗次數
fail_sum=`cat /tmp/test.txt | grep 'sshd' | grep 'Failed password' | grep "$today" | grep "$INTERNEL_IP" | wc -l`
/bin/rm -f /tmp/test.txt

# 判斷條件 - 本機try登入失敗超過三次
if (("$fail_sum" > "3")); then

# 設定iptables規則，紀錄log-uid
iptables -I INPUT -i lo -p tcp --dport 22 -j LOG --log-uid --log-prefix "AbuseSSH"

sleep 120

# 寄送通知信件至技術支援
iptable_messages=`cat /var/log/messages | grep 'AbuseSSH'`
echo "$iptable_messages" | mutt -s `hostname`' 目前此主機有惡意程式正在try SSH服務，請登入主機進行確認(先找信件內容uid是誰)' jacky@host.com.tw

# 取消iptables規則
iptables -D INPUT -i lo -p tcp --dport 22 -j LOG --log-uid --log-prefix "AbuseSSH"

fi
